<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v2.00                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2013                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/
// by WebMan v.7 (03.08.2014)

if(!defined('VALID_RUN')) { die('ACCESS DENIED'); }

class cmsDebug {

  private static $instance;
  
  public $config;  // Текущая рабочая конфигурация
  
  //----------------------------------------------------------------------------
  // Массив с информацией об отладке, доступный снаружи через get()
  // (время - в округлённых милисекундах)
  // Актуализируется на текущий момент из локальных переменных вызовом debugCalc()
  private $data = array(
    'full_time'         => 0,  // Полное время выполнения (скрипт + отладка)
    'script_time'       => 0,  // Время выполнения скрипта (без учёта времени отладки)
    'debug_time'        => 0,  // Суммарное время, потраченное модулем отладки

    'php_time'          => 0,  // Суммарное время выполнения php в скрипте (без SQL)
  
    'point_count'       => 0,  // Количество контрольных точек

    'sql_time'          => 0,  // Суммарное время всех подключений и запросов к БД
    'sql_time_connect'  => 0,  // Суммарное время всех подключений к БД
    'sql_time_query'    => 0,  // Суммарное время всех запросов
    'sql_count_connect' => 0,  // Количество подключений к БД
    'sql_count_query'   => 0,  // Количество запросов к БД

    'auto_time'         => 0,  // Суммарное время всех автозагрузок классов
    'auto_count'        => 0,  // Количество автозагрузок классов

    'include_time'      => 0,  // Суммарное время всех инклудов
    'include_count'     => 0,  // Количество инклудов

    'hook_time'         => 0,  // Суммарное время всех хуков
    'hook_count'        => 0,  // Количество отработавших хуков
    'hook_events'       => 0,  // Количество произошеших событий

    'widget_time'       => 0,  // Суммарное время всех виджетов
    'widget_count'      => 0,  // Количество виджетов

    'control_time'      => 0,  // Время работы контроллера

    'render_time'       => 0,  // Время отрисовки всей страницы

    'cache_time'        => 0,  // Суммарное время всех обращений к кэшу
    'cache_time_set'    => 0,  // Суммарное время всех обращений SET к кэшу
    'cache_time_get'    => 0,  // Суммарное время всех обращений GET к кэшу
    'cache_count_set'   => 0,  // Количество обращений SET к кэшу
    'cache_count_get'   => 0,  // Количество обращений GET к кэшу

    'memory_start'      => 0,  // Начальное значение памяти скрипта
    'memory_end'        => 0,  // Конечное значение памяти скрипта
    'memory_used'       => 0,  // Использование памяти скриптом (memory_end - memory_start)
    'memory_peak'       => 0,   // Максимальное использование памяти скриптом
    'debug_memory'      => 0,   // Память, использованная модулем отладки, в МБ
  );

  //----------------------------------------------------------------------------
  // Переменные
  private $time_start         = 0;  // Время старта скрипта
  private $debug_time_start   = 0;  // Время старта участка кода отладки
  private $debug_time         = 0;  // Суммарное время, потраченное модулем отладки, в секундах
  private $debug_memory       = 0;  // Суммарная память, использованная модулем отладки, в байтах
  private $debug_memory_start = 0;  // Значение памяти на момент старта участка кода отладки, в байтах

  private $point_time_last          = 0;  // Время предыдущей контрольной точки
  private $point_sql_time_last      = 0;  // Время коннектов и запросов к БД в предыдущей контрольной точке
  private $point_sql_count_last     = 0;  // Количество коннектов и запросов к БД в предыдущей контрольной точке
  private $point_include_time_last  = 0;  // Время автозагрузок и инклудов в предыдущей контрольной точке
  private $point_include_count_last = 0;  // Количество автозагрузок и инклудов в предыдущей контрольной точке
  private $point_hook_time_last     = 0;  // Время хуков в предыдущей контрольной точке
  private $point_hook_count_last    = 0;  // Количество хуков в предыдущей контрольной точке
  private $point_memory_last        = 0;  // Значение памяти в предыдущей контрольной точке
  private $point_debug_on_sql       = FALSE;  // Временно включить показ коннектов и запросов к БД после этой контрольной точки
  private $point_debug_on_include   = FALSE;  // Временно включить показ автозагрузок и инклудов после этой контрольной точки

  private $control_time_start = 0;  // Время старта контроллера

  private $render_time_start  = 0;  // Время старта отрисовки страницы

  private $sql_time_start     = 0;  // Время старта запроса SQL, пересчитывается для каждого запроса
  private $sql_time_connect   = 0;  // Суммарное время всех подключений к БД в секундах
  private $sql_time_query     = 0;  // Суммарное время всех запросов в секундах

  private $auto_time_start    = 0;  // Время старта автозагрузки ядра и классов, пересчитывается для каждой загрузки
  private $auto_time          = 0;  // Суммарное время всех автозагрузок в секундах

  private $include_time_start = 0;  // Время старта инклуда, пересчитывается для каждого инклуда
  private $include_time       = 0;  // Суммарное время всех инклудов в секундах

  private $hook_time_start    = 0;  // Время старта хука, пересчитывается для каждого хука
  private $hook_time          = 0;  // Суммарное время всех хуков в секундах

  private $widget_time_start  = 0;  // Время старта виджета, пересчитывается для каждого виджета
  private $widget_time        = 0;  // Суммарное время всех виджетов в секундах

  private $cache_time_start   = 0;  // Время старта обращения к кэшу, пересчитывается при каждом обращении
  private $cache_time_set     = 0;  // Суммарное время всех обращений SET к кэшу в секундах
  private $cache_time_get     = 0;  // Суммарное время всех обращений GET к кэшу в секундах
  
  private $includes = array();  // Массив инклудов
  
  private $events   = array();  // Массив событий
  private $hooks    = array();  // Массив хуков
  
  private $widgets  = array();  // Массив виджетов

  private $debug_html = "";  // html-строка с отладочной инфой

  private $errors_html = "";  // html-строка с инфой об ошибках PHP

// =============================================================================

  public function __construct($params="", $start_time=0, $start_memory = 0) {
    if ($start_time > 0) {
      $this->time_start = $start_time;
    } else {
      $this->time_start = microtime(TRUE);
    }
    $this->point_time_last = $this->time_start;
    
    if ($start_memory == 0) $start_memory = memory_get_usage();
    
    $this->config = cmsDebugConfig::GetInstance($params);

    $this->data['memory_start'] = $this->memoryRound(memory_get_usage($this->config->memory_real_usage));
    $this->point_memory_last = $this->data['memory_start'];
    
    $this->debug_time = microtime(TRUE) - $this->time_start;
    
    if ($this->config->debug_on_error) {
      // Установливаем уровень перехвата ошибок и свои обработчики ошибок
      error_reporting (E_ALL | E_STRICT);
      $old_error_handler = set_error_handler(array($this, "catchError"));
      register_shutdown_function(array($this, "catchFatal"));
      // Включаем/выключаем вывод ошибок на экран
      ini_set('display_errors', ($this->config->error_display ? 'On' : 'Off'));
    }
    
    $this->debug_memory = memory_get_usage() - $start_memory;
  }

  public function __clone() {}

  public static function getInstance($params="", $start_time=0) {
    if (self::$instance === null) self::$instance = new self($params, $start_time);
    return self::$instance;
  }

  public function __get($name) {
      return (isset($this->data[$name]) ? $this->data[$name] : FALSE );
  }

  public static function get($key) {
      return self::getInstance()->$key;
  }

// =============================================================================

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала соединения к БД
  * Вставляется непосредственно перед началом соединения
  */
  public function beginConnect() {
    $this->sql_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime соединений с БД
  * Вставляется непосредственно после всех операторов соединения
  * @param str $params Строка параметров соединения для лога, выводится без изменений
  */
  public function endConnect($params="") {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->sql_time_start;
    $this->sql_time_connect += $rt;
    $this->data['sql_time_connect'] = $this->timeRound($this->sql_time_connect);
    $this->data['sql_time'] = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
    $this->data['sql_count_connect']++;
    
    // Выход, если отладка SQL запрещена
    if (!$this->config->debug_on_sql && !$this->point_debug_on_sql) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Выход, если включены фильтры для SQL
    if ($this->config->filter_query_sql <> "" || $this->config->filter_query_from <> "") {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_sql+1, 1); // Задаём пропуск вызовов из cmsDatabase

    $this->debug_html .= "\n<div class='debug_row'><span class='connect'>Connect ".$this->data['sql_count_connect']."</span> - <strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."</tt>";
    $this->debug_html .= "<br/><pre class='params'>".$params."</pre>";
    $this->debug_html .= $trace['html']."\n</div>";
    
    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала запроса к БД
  * Вставляется непосредственно перед запросом mysql_query
  */
  public function beginQuery() {
    $this->sql_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime запроса
  * Вставляется непосредственно после запроса mysql_query
  * @param string $sql Строка запроса для лога, выводится без изменений
  * @param array $info Массив с информацией о работе запроса для лога
  */
  public function endQuery($sql="", $info) {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->sql_time_start;
    $this->sql_time_query += $rt;
    $this->data['sql_time_query'] = $this->timeRound($this->sql_time_query);
    $this->data['sql_time'] = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
    $this->data['sql_count_query']++;
    
    // Выход, если отладка SQL запрещена
    if (!$this->config->debug_on_sql && !$this->point_debug_on_sql) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Выход, если не удовлетворяет фильтру по SQL-строке запроса
    if ($this->config->filter_query_sql <> "") {
      if (!mb_stripos($sql, $this->config->filter_query_sql)) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_sql+2, 2); // Задаём пропуск вызовов из cmsDatabase
    
    // Выход, если не удовлетворяет фильтру по пути/имени вызывающего файла
    if ($this->config->filter_query_from <> "") {
      if (!mb_stripos($trace['point'], $this->config->filter_query_from)) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    $this->debug_html .= "\n<div class='debug_row".($this->config->query_heavy && ($rt*1000 > $this->config->query_heavy) ? " heavy" : "")."'><span class='query'>Query ".$this->data['sql_count_query']."</span> - <strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>Affected/returned rows: <strong>".$info['affected_rows']."</strong>&nbsp;&nbsp;&nbsp;".$info['info'];
    if ($info['errno'] > 0) $this->debug_html .= "<br>\n<span class='error'>Error ".$info['errno'].": ".$info['error']."</span>";
    if ($info['warnings']) $this->debug_html .= "<span class='warning'>".$info['warnings']."</span>";
    $this->debug_html .= "<br/><pre class='params'>".nl2br(trim($sql), true)."</pre>";
    $this->debug_html .= $trace['html']."\n</div>";

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала автозагрузки
  * Вставляется перед инклудом в автозагрузке
  */
  public function beginAutoload() {
    $this->auto_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime автозагрузки
  * Вставляется после инклуда в автозагрузке
  * @param string $class Класс для автозагрузки
  * @param string $file Путь к подключаемому файлу
  * @param void $result Результат попытки автозагрузки
  */
  public function endAutoload($class="", $file="", $result="") {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->auto_time_start;
    $this->auto_time += $rt;
    $this->data['auto_time'] = $this->timeRound($this->auto_time);
    $this->data['auto_count']++;
    
    // Выход, если отладка автозагрузки запрещена
    if (!$this->config->debug_on_auto && !$this->point_debug_on_include) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Выход, если не удовлетворяет фильтру по пути/имени подключаемого файла
    if ($this->config->filter_auto_file <> "") {
      if (!mb_stripos($file, $this->config->filter_auto_file)) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_auto+2, 2); // Задаём пропуск вызовов из autoload.php

    // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
    if ($this->config->filter_auto_from <> "") {
      if (!mb_stripos($trace['point'], $this->config->filter_auto_from)) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    $this->debug_html .= "\n<div class='debug_row'><span class='auto'>Autoload ".$this->data['auto_count']."</span> - <strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>Result: ".($result==1 ? "<span class='ok'>OK</span>" : "<span class='error'>".$result."</span>");
    $this->debug_html .= "<br/><pre class='params'>".$class."  -  ".($file ? "/".$file : "")."</pre>";
    $this->debug_html .= $trace['html']."\n</div>";

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала инклуда
  * Вставляется перед инклудом
  */
  public function beginInclude() {
    $this->include_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime инклуда
  * Вставляется после инклуда
  * @param string $file Путь к подключаемому файлу
  * @param void $result Результат попытки инклуда
  */
  public function endInclude($file="", $result="") {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->include_time_start;
    $this->include_time += $rt;
    $this->data['include_time'] = $this->timeRound($this->include_time);
    $this->data['include_count']++;

    // Выход, если отладка инклуда запрещена
    if (!$this->config->debug_on_include && !$this->point_debug_on_include) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Подготавливаем путь
    $root_path = cmsConfig::getInstance()->root_path;
    if (substr($file, 0, strlen($root_path)) == $root_path) $file = substr($file, strlen($root_path));
    
    // Выход, если не удовлетворяет фильтру по пути/имени подключаемого файла
    if ($this->config->filter_include_file <> "") {
      if (!mb_stripos($file, $this->config->filter_include_file)) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_include+1, 1); // Задаём пропуск вызовов из includeFile()
    
    // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
    if ($this->config->filter_include_from <> "") {
      if (!mb_stripos($trace['point'], $this->config->filter_include_from)) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Сохраняем данные для таблицы количеств инклудов
    if ($file) {
      // Считаем количества
      if (array_key_exists($file, $this->includes)) {
        $this->includes[$file]['count']++;
        $this->includes[$file]['time'] += $this->timeRound($rt);
      } else {
        $this->includes[$file]['count'] = 1;
        $this->includes[$file]['time']  = $this->timeRound($rt);
        $this->includes[$file]['error'] = 0;
      }
      // Считаем ошибки
      $result_bool = ($result == 1 || is_array($result));
      if ($result_bool == FALSE) $this->includes[$file]['error']++;
    }

    $this->debug_html .= "\n<div class='debug_row'><span class='include'>Include ".$this->data['include_count']."</span> - <strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>Result: ".($result_bool ? "<span class='ok'>OK</span>" : "<span class='error'>".$result."</span>");
    $this->debug_html .= "<br/><pre class='params'>".(substr($file, 0, 1)!="/" && substr($file, 1, 1)!=":" ? "/" : "").$file."</pre>";
    $this->debug_html .= $trace['html']."\n</div>";

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Фиксирует произошедшие события (перед вызовом хуков)
  */
  public function logEvent($event_name="") {
    $this->startDebugRuntime();
    
    // Сохраняем количество событий
    $this->data['hook_events']++;

    // Выход, если отладка хуков запрещена
    if (!$this->config->debug_on_hook) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Выход, если не удовлетворяет фильтру по событию
    if ($this->config->filter_hook_event <> "none") {
      if ($event_name != $this->config->filter_hook_event) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Выход, если задан фильтр по контроллеру
    if ($this->config->filter_hook_control <> "none") {
      $this->updateDebugRuntime();
      return true;
    }

    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_hook+1, 1); // Задаём пропуск вызовов из debug.php
    
    // Сохраняем данные для таблицы количеств событий
    if (isset($this->events[$event_name]) && array_key_exists($event_name, $this->events)) {
      $this->events[$event_name] ++;
    } else {
      $this->events[$event_name] = 1;
    }

    $this->debug_html .= "\n<div class='debug_row'><span class='event'>Event ".$this->data['hook_events']."&nbsp;&nbsp;'<strong><tt>".$event_name."</tt></strong>'</span>";
    $this->debug_html .= "<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>";
    $this->debug_html .= $trace['html']."\n</div>";
    
    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала хука
  * Вставляется перед хуком
  */
  public function beginHook() {
    $this->hook_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime хука
  * Вставляется после хука
  * @param string $event_name  Событие
  * @param void $data          Данные, передаваемые в хук
  * @param void $result        Результат, возвращаемый хуком
  */
  public function endHook($event_name="", $listener="", $data=FALSE, $result=FALSE) {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->hook_time_start;
    $this->hook_time += $rt;
    $this->data['hook_time'] = $this->timeRound($this->hook_time);
    $this->data['hook_count']++;

    // Выход, если отладка хуков запрещена
    if (!$this->config->debug_on_hook) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Выход, если не удовлетворяет фильтру по событию
    if ($this->config->filter_hook_event <> "none") {
      if ($event_name != $this->config->filter_hook_event) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Выход, если не удовлетворяет фильтру по контроллеру
    if ($this->config->filter_hook_control <> "none") {
      if ($listener != $this->config->filter_hook_control) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_hook+1, 1); // Задаём пропуск вызовов из debug.php
    
    // Сохраняем данные для таблицы количеств хуков
    if (isset($this->hooks[$event_name][$listener]) && array_key_exists($listener, $this->hooks[$event_name])) {
      $this->hooks[$event_name][$listener]['count'] ++;
      $this->hooks[$event_name][$listener]['time'] += $this->timeRound($rt);
    } else {
      $this->hooks[$event_name][$listener]['count'] = 1;
      $this->hooks[$event_name][$listener]['time'] = $this->timeRound($rt);
    }

    $this->debug_html .= "\n<div class='debug_row".($this->config->hook_heavy && ($rt*1000 > $this->config->hook_heavy) ? " heavy" : "")."'><span class='hook'>Hook ".$this->data['hook_count']."&nbsp;&nbsp;'<strong><tt><span class='event help' title='Event'>".$event_name."</span> → <span class='help' title='Controller'>".$listener."</span></tt></strong>'</span> - ";
    $this->debug_html .= "<strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>";
    if ($this->config->hook_log_data) {
        $this->debug_html .= ($data ? "<br/>Data:<br/><pre class='params'>".print_r($data, TRUE)."</pre>" : "");
        $this->debug_html .= ($result ? "<br/>Result:<br/><pre class='params'>".print_r($result, TRUE)."</pre>" : "");
    }
    $this->debug_html .= $trace['html']."\n</div>";

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время старта виджета
  * Вставляется перед виджетом
  */
  public function beginWidget() {
    $this->widget_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime виджета
  * Вставляется после вызова виджета
  * @param array $widget  Массив данных виджета
  * @param void $result   Результат, возвращаемый виджетом
  */
  public function endWidget($widget=FALSE, $result=FALSE) {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->widget_time_start;
    $this->widget_time += $rt;
    $this->data['widget_time'] = $this->timeRound($this->widget_time);
    $this->data['widget_count']++;

    // Выход, если отладка виджетов запрещена
    if (!$this->config->debug_on_widget) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Получаем имя виджета и контроллера
    $widget_name = "";
    if ($widget && array_key_exists("name", $widget)) $widget_name = $widget['name'];
    $controller = "";
    if ($widget && array_key_exists("controller", $widget)) $controller = $widget['controller'];
    
    // Выход, если не удовлетворяет фильтру по имени виджета
    if ($this->config->filter_widget_widget <> "none") {
      if ($widget_name != $this->config->filter_widget_widget) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Выход, если не удовлетворяет фильтру по контроллеру
    if ($this->config->filter_widget_control <> "none") {
      if ($controller != $this->config->filter_widget_control) {
        $this->updateDebugRuntime();
        return true;
      }
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_widget+1, 1); // Задаём пропуск вызовов из debug.php
    
    // Сохраняем данные для таблицы виджетов
    if (isset($this->widgets[$controller][$widget_name]) && array_key_exists($widget_name, $this->widgets[$controller])) {
      $this->widgets[$controller][$widget_name]['count'] ++;
      $this->widgets[$controller][$widget_name]['time'] += $this->timeRound($rt);
    } else {
      $this->widgets[$controller][$widget_name]['count'] = 1;
      $this->widgets[$controller][$widget_name]['time'] = $this->timeRound($rt);
    }

    $this->debug_html .= "\n<div class='debug_row".($this->config->widget_heavy && ($rt*1000 > $this->config->widget_heavy) ? " heavy" : "")."'><span class='widget'>Widget ".$this->data['widget_count']."&nbsp;&nbsp;'<strong><tt><span class='help' title='Widget'>".$widget_name."</span>".($controller ? " → <span class='help' title='Controller'>".$controller."</span>" : "")."</tt></strong>'</span> - ";
    $this->debug_html .= "<strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>";
    if ($this->config->widget_log_data) {
        $this->debug_html .= ($widget ? "<br/>Data:<br/><pre class='params'>".print_r($widget, TRUE)."</pre>" : "");
        $this->debug_html .= ($result ? "<br/>Result:<br/><pre class='params'>".print_r($result, TRUE)."</pre>" : "");
    }
    $this->debug_html .= $trace['html']."\n</div>";

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала старта контроллера
  * Вставляется непосредственно перед стартом контроллера
  */
  public function beginController() {
    $this->control_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет время работы контроллера
  * Вставляется непосредственно после отработки контроллера
  */
  public function endController() {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $this->data['control_time'] = $this->timeRound($this->debug_time_start - $this->control_time_start);
    
    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала отрисовки страницы
  * Вставляется непосредственно перед началом рендеринга
  */
  public function beginRender() {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $this->render_time_start = $this->debug_time_start;
    // Выводим в Админке предупреждение о включённой отладке
    if (cmsCore::getInstance()->uri_controller == "admin" && cmsDebugConfig::getInstance()->get("debug_on")) cmsUser::addSessionMessage(LANG_CP_DEBUG_ON_WARNING, 'error');

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет время отрисовки страницы
  * Вставляется непосредственно после ренедеринга страницы
  */
  public function endRender() {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $this->data['render_time'] = $this->timeRound($this->debug_time_start - $this->render_time_start);
    
    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Запоминает время начала работы с кэшем
  *  Вставляется перед началом работы кэша
  */
  public function beginCache() {
    $this->cache_time_start = microtime(TRUE);
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет замеры runtime кэша
  * Вставляется по окончании работы кэша
  * @param string $type Тип запроса к кэшу (set, get)
  * @param string $key Ключ элемента кэша
  * @param int $result Результат обращения - размер элемента (для set - в байтах, для get - количество элементов массива)
  */
  public function endCache($type="", $key="", $result="") {
    $this->startDebugRuntime();
    
    // Сохраняем runtime
    $rt = $this->debug_time_start - $this->cache_time_start;
    $type=strtolower($type);
    if ($type == "set") {
      $this->cache_time_set += $rt;
      $this->data['cache_time_set'] = $this->timeRound($this->cache_time_set);
      $this->data['cache_count_set']++;
      $result = ($result ? $result : 0)." bytes";
    }
    if ($type == "get") {
      $this->cache_time_get += $rt;
      $this->data['cache_time_get'] = $this->timeRound($this->cache_time_get);
      $this->data['cache_count_get']++;
      if (is_numeric($result)) {
        $result = ($result ? $result : 0)." items";
      } else {
        $result = "<span class='error'>".$result."</span>";
      }
    }
    $this->data['cache_time'] = $this->data['cache_time_set'] + $this->data['cache_time_get'];
    
    // Выход, если отладка кэша запрещена
    if (!$this->config->debug_on_cache) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Трассировка вызовов
    $trace = $this->getTrace($this->config->trace_level_cache+1, 1); // Задаём пропуск вызовов из cache.php

    $this->debug_html .= "\n<div class='debug_row'><span class='cache_".$type."'>Cache <strong>".strtoupper($type)."</strong> ".($this->data['cache_count_set'] + $this->data['cache_count_get'])."</span> - <strong>".$this->timeRound($rt)."</strong> ms<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."&nbsp;&nbsp;&nbsp;</tt>Result: <span class='ok'>".$result."</span>";
    $this->debug_html .= "<br/><pre class='params'>key: ".$key."</pre>";
    $this->debug_html .= $trace['html']."\n</div>";

    $this->updateDebugRuntime();
    return true;
  }

  // ---------------------------------------------------------------------------
  /**
  * Подсчитывает и сохраняет runtime с момента предыдущей точки или со старта скрипта, если это первая точка
  * Вставляется в нужное место кода строкой вида:
  * if (DEBUG_ON) cmsDebug::getInstance()->checkPoint("NAME","param=".$param, 5, true, true);
  * Все параметры необязательные
  * @param string $name Название точки, выводится в лог в кавычках после "CheckPoint"
  * @param string $params Строка параметров для лога, выводится без изменений
  * @param int $trace_level Глубина трассировки вызовов, 0 - выключить, -1 - по умолчанию из конфига
  * @param bool $sql_debug Временно включить показ SQL с этой контрольной точки
  * @param bool $include_debug Временно включить показ инклудов с этой контрольной точки
  */
  public function checkPoint($name="", $params="", $trace_level=-1, $sql_debug = FALSE, $include_debug = FALSE) {
    $this->startDebugRuntime();
    
    $this->data['point_count']++;
    
    // Выход, если показ контрольных точек запрещён
    if (!$this->config->debug_on_point) {
      $this->updateDebugRuntime();
      return true;
    }
    
    // Память и время точки
    $mem = $this->memoryRound(memory_get_usage($this->config->memory_real_usage));
    $rt = $this->debug_time_start - $this->point_time_last;
    $this->point_time_last = $this->debug_time_start;
    $mem_delta = round($mem - $this->point_memory_last, 3) * 1000;
    $this->point_memory_last = $mem;
    
    // Количество и время SQL
    $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->point_sql_count_last;
    if ($sql_count > 0) {
      $this->point_sql_count_last = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
      $sql_time = $this->sql_time_connect + $this->sql_time_query - $this->point_sql_time_last;
      $this->point_sql_time_last = $this->sql_time_connect + $this->sql_time_query;
    }
    
    // Количество и время автозагрузок и инклудов
    $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->point_include_count_last;
    if ($include_count > 0) {
      $this->point_include_count_last = $this->data['auto_count'] + $this->data['include_count'];
      $include_time = $this->auto_time + $this->include_time - $this->point_include_time_last;
      $this->point_include_time_last = $this->auto_time + $this->include_time;
    }
    
    // Количество и время хуков
    $hook_count = $this->data['hook_count'] - $this->point_hook_count_last;
    if ($hook_count > 0) {
      $this->point_hook_count_last = $this->data['hook_count'];
      $hook_time = $this->hook_time - $this->point_hook_time_last;
      $this->point_hook_time_last = $this->hook_time;
    }
    
    // Трассировка вызовов
    if ($trace_level==-1) $trace_level = $this->config->trace_level_point;
    $trace = $this->getTrace($trace_level+1, 1);

    $this->debug_html .= "\n<div class='debug_row'><span class='point'>Point ".$this->data['point_count'].($name ? "&nbsp;&nbsp;'<strong><tt>".$name."</tt></strong>'" : "")."</span> - ";
    $this->debug_html .= "<strong>".$this->timeRound($rt)."</strong> ms - ";
    $this->debug_html .= "[ ".($sql_count==0 ? 0 : "<strong>".$sql_count."</strong>")." sql : ".($sql_count==0 ? 0 : "<strong>".$this->timeRound($sql_time)."</strong>")." ms ]";
    $this->debug_html .= "[ ".($include_count==0 ? 0 : "<strong>".$include_count."</strong>")." incl : ".($include_count==0 ? 0 : "<strong>".$this->timeRound($include_time)."</strong>")." ms ]";
    $this->debug_html .= "[ ".($hook_count==0 ? 0 : "<strong>".$hook_count."</strong>")." hooks : ".($hook_count==0 ? 0 : "<strong>".$this->timeRound($hook_time)."</strong>")." ms ]";
    $this->debug_html .= "[ ".($mem_delta==0 ? "0" : "<strong>".($mem_delta>0 ? "+" : "").$mem_delta."</strong> KB")." : <strong>".$mem."</strong> MB ]";
    $this->debug_html .= "<tt>&nbsp;&nbsp;&nbsp;".$trace['point']."</tt>";
    $this->debug_html .= ($params ? "<br/><pre class='params'>".print_r($params, TRUE)."</pre>" : "");
    $this->debug_html .= $trace['html']."\n</div>";

    $this->point_debug_on_sql = $sql_debug; // Сохраняем признак временной отладки SQL
    $this->point_debug_on_include = $include_debug; // Сохраняем признак временной отладки инклудов

    $this->updateDebugRuntime();
    return true;
  }
  
  /**
  * Обработчик некритических ошибок PHP
  * Перехватывает ошибки PHP-скриптов и сохраняет их для вывода в лог или в файл.
  */
  public function catchError($errno, $errstr, $errfile, $errline, $errcontext) {
    $dt=date("Y.m.d H:i:s");
    
    // Убираем из пути скрипта домашнюю папку сервера
    $errfile = str_replace($_SERVER['DOCUMENT_ROOT'], "", str_replace("\\", "/", $errfile));
    
    $errtype = $this->getErrorType($errno);
    // Получаем признак фатальной ошибки
    $critical = ($errno & (E_ERROR | E_PARSE | E_COMPILE_ERROR | E_CORE_ERROR));
    
    // Трассировка вызовов только для нефатальных ошибок
    // Так как при фатальных ошибках debug_backtrace() ничего полезного не возвращает
    $trace_html = "";
    if (!$critical) {
      $trace = $this->getTrace($this->config->trace_level_error, 0);
      $trace_html = $trace['html'];
    }
   
    $this->errors_html .= "\n<div class='debug_error'><span class='err'>".($critical ? "<strong><span class='error'>Fatal error ".$errtype."</span>: ".$errstr."</strong>" : "<span class='warning'>".$errtype."</span>: ".$errstr)."</span>";
    $this->errors_html .= "<tt>&nbsp;&nbsp;&nbsp;<span class='file'>".$errfile." (".$errline.")</span></tt>";
    if ($this->config->error_log_data) $this->errors_html .= ($errcontext ? "<br/><pre class='params'>".print_r($errcontext, TRUE)."</pre>" : "");
    $this->errors_html .= $trace_html."\n</div>";

    $user = cmsUser::getInstance();
    $user_str = ($user->id > 0 ? $user->id."&ensp;'".$user->nickname."'&ensp;(".$user->email.")" : "guest");
    $page_url = cmsConfig::getInstance()->host.href_to_current();

        // Подготовка письма админу о критической ошибке
    if ($critical && ($this->config->error_critical_mail || 
                      $this->config->error_critical_msg  || 
                      $this->config->error_critical_notice)) {
                     
        
        $letter = "<strong>Fatal error</strong> $errtype: $errstr.<br/>\r\n".
                  "in <strong>$errfile</strong> at line <strong>$errline</strong><br/>\r\n".
                  "user:&ensp;$user_str<br/>\r\n".
                  "url: <a href='$page_url'>$page_url</a>";
    }
    
    // Отправка email админу о критической ошибке
    if ($critical && $this->config->error_critical_mail) {
        $messenger = cmsCore::getController('messages');
        $user_to = cmsCore::getModel('users')->getUser($this->config->error_critical_user);
        $to = array('email' => $user_to['email'], 'name' => "");
        $messenger->sendEmail($to, array('text' => $letter));
    }
    
    // Отправка уведомления админу о критической ошибке
    if ($critical && $this->config->error_critical_notice) {
        $messenger = cmsCore::getController('messages');
        $messenger->addRecipient($this->config->error_critical_user);
        $messenger->sendNoticePM(array(
            'content' => $letter
        ));
    }
    
    // Отправка личного сообщения админу о критической ошибке
    if ($critical && $this->config->error_critical_msg) {
        $messenger = cmsCore::getController('messages');
        $messenger->clearRecipients();
        $messenger->setSender($this->config->error_critical_user);
        $messenger->addRecipient($this->config->error_critical_user);
        $messenger->sendMessage($letter);
    }
    
    return true;
  }
  
  /**
  * Обработчик фатальных ошибок PHP
  * Перехватывает критические неисправимые ошибки PHP-скриптов и 
  * передаёт их в catchError() для вывода в лог на экран и в файл.
  * Потом выводит сообщение об ошибке, а также всю накопленную к этому моменту
  * информацию (готовая часть страницы и отладка) и останавливает работу скриптов.
  */
  public function catchFatal() {
    $errno = 0;
    
    if (@is_array($e = @error_get_last())) {
      $errno = isset($e['type']) ? $e['type'] : 0;
      $errstr = isset($e['message']) ? $e['message'] : "";
      $errfile = isset($e['file']) ? $e['file'] : "";
      $errline = isset($e['line']) ? $e['line'] : "";
    }

    if ($errno > 0) {
      $this->catchError($errno, $errstr, $errfile, $errline, "");
      if ($this->allowShow()) {
        // Если разрешено (то есть, страницу смотрит админ), 
        // выводим страницу (всё, что есть к этому моменту) и отладочную инфу
        $this->debugCalc;
        echo $this->getHtmlFull();
        ob_end_flush();
      } else {
        // Если запрещено, то выводим для пользователей
        ob_clean;
        // Выводим сообщение об ошибке сервера
        header($_SERVER['SERVER_PROTOCOL']." 500 Internal Server Error", true, 500);
        header("Status: 500 Internal Server Error", true, 500);
        if ($this->config->error_critical_page) {
          // Выводим сообщение пользователю на чистой странице
          echo $this->config->error_critical_page;
        } else {
          echo "500 Internal Server Error";
        }
      }
      exit;
    }
    
  }

  // ---------------------------------------------------------------------------
  /**
  * Обратная трассировка вызовов функций
  * @param int $trace_level
  * @param int $shift
  * @return array 
  *   'point' Строка с местом нахождения сработавшей точки отладки CheckPoint
  *   'html'  Строка html со списком вызывавших функций
  */
  private function getTrace($trace_level=10, $shift=0) {
    $this->startDebugRuntime();
    
    $html = "";
    $point = "";
    
    $bt=debug_backtrace();
    $lvl = -1;
    $sp = 1; // Начальный сдвиг трассировки вправо
    foreach ($bt as $k=>$v) {
      $lvl++;
      if ($lvl<=$shift) continue;
      if ($lvl>$trace_level+1) break;
      extract($v);
      if (!isset($file)) $file = "";
      if (!isset($line)) $line = "";

      if ($file == "" && $line == "" && $function == "spl_autoload_call") {
        $shift++; // Сдвиг на следующий уровень для пропуска spl_autoload_call без файла
        continue;
      }

/*      if ($shift && strstr($file, "database.php")) {
        $shift++; // Сдвиг на следующий уровень для пропуска cmsDatabase
        continue;
      }
*/
      $file = str_replace($_SERVER['DOCUMENT_ROOT'], "", str_replace("\\", "/", $file));
      if ($lvl==1+$shift) {  // Сработавшая точка отладки
        if ($function == "DebugCheckPoint") $function = "";
        $point = $file." (".$line.") ";
        if ($function) $point .= (isset($class) ? $class.$type : "").$function;
      } else {  // Остальные вызвавшие функции
        $html .= "<br/>".str_repeat("&nbsp;&nbsp;", $sp++);
        $html .= $file." (".$line.") ".(isset($class) ? $class.$type : "").$function;
      }
    }
    
    $ret['point'] = "<span class='file'>".$point."</span>";
    $ret['html'] = "<span class='trace'>".$html."</span>";

    $this->updateDebugRuntime();
    return $ret;
  }

  // ---------------------------------------------------------------------------
  /**
  * Вычисляет оставшиеся значения runTime
  */
  public function debugCalc() {
    $now = microtime(TRUE);
    
    $this->data['memory_end']  = $this->memoryRound(memory_get_usage($this->config->memory_real_usage));
    $this->data['memory_peak'] = $this->memoryRound(memory_get_peak_usage($this->config->memory_real_usage));
    $this->data['memory_used'] = $this->data['memory_end'] - $this->data['memory_start'];

    $this->data['full_time']   = $this->timeRound($now - $this->time_start);
    $this->data['debug_time']  = $this->timeRound($this->debug_time);
    $this->data['debug_time1'] = $this->data['debug_time'];
    $this->data['script_time'] = $this->data['full_time'] - $this->data['debug_time'];
    $this->data['php_time']    = $this->data['script_time'] - $this->data['sql_time'] - $this->data['cache_time'];    

    $this->data['debug_memory']  = $this->memoryRound($this->debug_memory);
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает html-строку с итоговой таблицей и подробной информацией по отладке
  * @return string
  */
  public function getHtmlFull() {
    return "<div id='debug'><div class='wrapper'>".$this->errors_html.$this->getHtmlTable().$this->getHtmlFilters().$this->getHtmlIncludes().$this->getHtmlHooks().$this->getHtmlWidgets().$this->debug_html."</div></div>";
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает готовую html-таблицу с итоговыми результатами замеров времени выполнения
  * @return string
  */
  private function getHtmlTable() {
    // Вычисляем значения runTime
    $this->debugCalc();
    
    $config = cmsConfig::getInstance();
    
    // --- Table header ---
    $html = "<table><thead><tr><td><u>Script</u><td><u>PHP</u></td><td><u>SQL</u></td><td><u>Cache</u> - ".($config->cache_enabled ? "<span class='cache_set'>on '".$config->cache_method."'</span>" : "off")."</td><td><u>Memory</u>".($this->config->memory_real_usage ? " (real)" : " (exact)")."</td></tr></thead><tbody><tr valign='top'>";

    // --- Script ---
    $html .= "<td><div class='script'>script time:&ensp;<font size='+1'><span class='help' title='Script runtime = full time - debug time'><strong>".$this->data['script_time']."</strong></span></font> ms</div>";
    // Emulate lag
    if ($this->config->emulate_lag>0) $html .= "<br/><div class='warning'>emulate lag:&ensp;<strong>".$this->config->emulate_lag."</strong> ms</div>";
    // Debug time
    $html .= "<br/><div class='debug_info'>debug time:&ensp;<span class='help' title='Class Debug runtime'><strong>".$this->data['debug_time']."</strong></span> ms <span class='help' title='Percent from full time'>(".$this->percent($this->data['full_time'], $this->data['debug_time'])."%)</span></div>";
    // Full time
    $html .= "<div class='debug_info'>full time:&ensp;<span class='help' title='Full runtime, total time of all script and debug parts'><strong>".$this->data['full_time']."</strong></span> ms</div>";
    // Points count
    $html .= ($this->data['point_count']>0 ? "<br/><div class='point'>check points:&ensp;<strong>".$this->data['point_count']."</strong></div>" : "");
    $html .= "</td>";

    // --- PHP ---
    $html .= "<td><div class='php'>php time:&ensp;<strong>".$this->data['php_time']." </strong> ms <span class='help' title='Percent from script time'>(".$this->percent($this->data['script_time'], $this->data['php_time'])."%)</span></div>";
    // Autoloads
    $html .= "<div class='auto info_block'>autoloads:<br/>- count:&ensp;<strong>".$this->data['auto_count']."</strong><br/>- time:&ensp;<strong>".$this->data['auto_time']."</strong> ms <span class='help' title='Percent from php time'>(".$this->percent($this->data['php_time'], $this->data['auto_time'])."%)</span></div>";
    // Includes
    $html .= "<div class='include info_block'>includes:<br/>- count:&ensp;<strong>".$this->data['include_count']."</strong><br/>- time:&ensp;<strong>".$this->data['include_time']."</strong> ms <span class='help' title='Percent from php time'>(".$this->percent($this->data['php_time'], $this->data['include_time'])."%)</span></div>";
    // Hooks
    $html .= "<div class='hook info_block'><span class='event'>events</span>/hooks:<br/>- count:&ensp;<span class='event help' title='Events count'><strong>".$this->data['hook_events']."</strong></span> / <span class='help' title='Hooks count'><strong>".$this->data['hook_count']."</strong></span><br/>- time:&ensp;<strong>".$this->data['hook_time']."</strong> ms <span class='help' title='Percent from php time'>(".$this->percent($this->data['php_time'], $this->data['hook_time'])."%)</span></div>";
    // Widgets
    $html .= "<div class='widget info_block'>widgets:<br/>- count:&ensp;<strong>".$this->data['widget_count']."</strong><br/>- time:&ensp;<strong>".$this->data['widget_time']."</strong> ms <span class='help' title='Percent from php time'>(".$this->percent($this->data['php_time'], $this->data['widget_time'])."%)</span></div>";
    // Controller
    $html .= "<div class='control info_block'>controller:&ensp;<strong>".$this->data['control_time']."</strong> ms <span class='help' title='Percent from php time'>(".$this->percent($this->data['php_time'], $this->data['control_time'])."%)</span></div>";
    // Render
    $html .= "<div class='render info_block'>rendering:&ensp;<strong>".$this->data['render_time']."</strong> ms <span class='help' title='Percent from php time'>(".$this->percent($this->data['php_time'], $this->data['render_time'])."%)</span></div></td>";

    // --- SQL ---
    $html .= "<td><div class='sql'>sql time:&ensp;<strong>".$this->data['sql_time']."</strong> ms <span class='help' title='Percent from script time'>(".$this->percent($this->data['script_time'], $this->data['sql_time'])."%)</span></div>";
    // Connects
    $html .= "<div class='connect info_block'>connects:<br/>- count:&ensp;<strong>".$this->data['sql_count_connect']."</strong><br/>- time:&ensp;<strong>".$this->data['sql_time_connect']."</strong> ms <span class='help' title='Percent from sql time'>(".$this->percent($this->data['sql_time'], $this->data['sql_time_connect'])."%)</span></div>";
    // Queries
    $html .= "<div class='query info_block'>queries:<br/>- count:&ensp;<strong>".$this->data['sql_count_query']."</strong><br/>- time:&ensp;<strong>".$this->data['sql_time_query']."</strong> ms <span class='help' title='Percent from sql time'>(".$this->percent($this->data['sql_time'], $this->data['sql_time_query'])."%)</span></div></td>";

    // --- Cache ---
    $html .= "<td><div class='cache'>cache time:&ensp;<strong>".$this->data['cache_time']."</strong> ms <span class='help' title='Percent from script time'>(".$this->percent($this->data['script_time'], $this->data['cache_time'])."%)</span></div>";
    // SET
    $html .= "<div class='cache_set info_block'>set:<br/>- count:&ensp;<strong>".$this->data['cache_count_set']."</strong><br/>- time:&ensp;<strong>".$this->data['cache_time_set']."</strong> ms <span class='help' title='Percent from cache time'>(".$this->percent($this->data['cache_time'], $this->data['cache_time_set'])."%)</span></div>";
    // GET
    $html .= "<div class='cache_get info_block'>get:<br/>- count:&ensp;<strong>".$this->data['cache_count_get']."</strong><br/>- time:&ensp;<strong>".$this->data['cache_time_get']."</strong> ms <span class='help' title='Percent from cache time'>(".$this->percent($this->data['cache_time'], $this->data['cache_time_get'])."%)</span></div></td>";

    // --- Memory ---
    $html .= "<td><div class='memory'>peak:&ensp;<span class='help' title='Maximum of memory usage'><strong>".$this->data['memory_peak']."</strong></span> MB</div>";
    // --- Use ---
    $html .= "<div class='memory_use info_block'>start:&ensp;<span class='help' title='Memory at script start'>".$this->data['memory_start']."</span> MB<br/>end:&ensp;<span class='help' title='Memory at script end'>".$this->data['memory_end']."</span> MB<br/>used:&ensp;<span class='help' title='Used memory = end - start'>".$this->data['memory_used']."</span> MB</div>";
    // --- Debug ---
    $html .= "<br /><div class='debug_info'>debug:&ensp;<span class='help' title='Memory of debugging'>".$this->data['debug_memory']."</span> MB</div></td>";
    
    $html .= "</tr></tbody></table>";
    return $html;
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает html-блок с описанием включённых фильтров
  * @return string
  */
  private function getHtmlFilters() {

    $html = "";

    // Фильтр по строке SQL по части строки запроса
    if ($this->config->debug_on_sql && $this->config->filter_query_sql <> "") {
      $html .= "<tr><td>SQL string:</td><td><tt>'<span class='query'>".$this->config->filter_query_sql."</span>'</tt></td></tr>";
    }

    // Фильтр по строке SQL
    if ($this->config->debug_on_sql && $this->config->filter_query_from <> "") {
      $html .= "<tr><td>SQL from:</td><td><tt>'<span class='query'>".$this->config->filter_query_from."</span>'</tt></td></tr>";
    }
    
    // Фильтр автозагрузок по подключаемому файлу
    if ($this->config->debug_on_auto && $this->config->filter_auto_file <> "") {
      $html .= "<tr><td>Autoloaded file:</td><td><tt>'<span class='auto'>".$this->config->filter_auto_file."</span>'</tt></td></tr>";
    }
    
    // Фильтр автозагрузок по подключающему файлу
    if ($this->config->debug_on_auto && $this->config->filter_auto_from <> "") {
      $html .= "<tr><td>Autoloaded from:</td><td><tt>'<span class='auto'>".$this->config->filter_auto_from."</span>'</tt></td></tr>";
    }
    
    // Фильтр инклудов по подключаемому файлу
    if ($this->config->debug_on_include && $this->config->filter_include_file <> "") {
      $html .= "<tr><td>Included file:</td><td><tt>'<span class='include'>".$this->config->filter_include_file."</span>'</tt></td></tr>";
    }
    
    // Фильтр инклудов по подключающему файлу
    if ($this->config->debug_on_include && $this->config->filter_include_from <> "") {
      $html .= "<tr><td>Included from:</td><td><tt>'<span class='include'>".$this->config->filter_include_from."</span>'</tt></td></tr>";
    }
    
    // Фильтр хуков по событию
    if ($this->config->debug_on_hook && $this->config->filter_hook_event <> "none") {
      $html .= "<tr><td>Event (for hooks):</td><td><tt>'<span class='event'>".$this->config->filter_hook_event."</span>'</tt></td></tr>";
    }
    
    // Фильтр хуков по контроллеру
    if ($this->config->debug_on_hook && $this->config->filter_hook_control <> "none") {
      $html .= "<tr><td>Controller (for hooks):</td><td><tt>'<span class='hook'>".$this->config->filter_hook_control."</span>'</tt></td></tr>";
    }
    
    // Фильтр виджетов по виджету
    if ($this->config->debug_on_widget && $this->config->filter_widget_widget <> "none") {
      $html .= "<tr><td>Widget (for widgets):</td><td><tt>'<span class='widget'>".$this->config->filter_widget_widget."</span>'</tt></td></tr>";
    }
    
    // Фильтр виджетов по контроллеру
    if ($this->config->debug_on_widget && $this->config->filter_widget_control <> "none") {
      $html .= "<tr><td>Controller (for widgets):</td><td><tt>'<span class='widget'>".$this->config->filter_widget_control."</span>'</tt></td></tr>";
    }

    if ($html <> "") $html = "<table class='filter'><thead><tr><td colspan=2 align='center'><u>Used filters</u></td></tr></thead><tbody>".$html."</tbody></table>";
    
    return $html;
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает готовую html-таблицу с количествами и временем инклудов файлов
  * @return string
  */
  private function getHtmlIncludes() {

    if (!$this->config->debug_on_include || count($this->includes) == 0) return "";
    
    $html = "";
    
    $lines = 0;

    ksort($this->includes, SORT_STRING);
    
    foreach ($this->includes as $f => $v) {
      if (!$this->config->includes_table_error || $v['count'] > 1 || $v['error'] > 0) {
        $html .= "<tr><td>".$f."</td><td".($v['count']>1 ? " class='warning'" : "")." align='center'>".$v['count']."</td><td align='center'>".($v['time']>0 ? $v['time'] : "")."</td><td align='center'".($v['error']>0 ? " class='error'>".$v['error'] : ">")."</td></tr>";
        $lines++;
      }
    }
    
    $html = "<table><thead><tr><td><u><span class='include'>Included files</span></u> (".$lines." from ".count($this->includes).")".($this->config->filter_include_file.$this->config->filter_include_from <> "" ? " - filter" : "")."</td><td><u>Count</u></td><td><u>Time sum, ms</u></td><td><u>Errors</u></td></tr></thead><tbody>".$html;
    $html .= "</tbody></table>";
    return $html;
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает готовую html-таблицу с событиями-хуками-контроллерами
  * @return string
  */
  private function getHtmlHooks() {
    
    if (!$this->config->debug_on_hook || $this->config->hook_table == "none") return "";
    
    $html = "";
    $html_thead = "";
    
    switch ($this->config->hook_table) {
    
        case "act_hooks":  // Только активные хуки - по хукам
            
            $html_thead = "<td><u><span class='event'>Hook</span></u></td><td><u><span class='hook'>Controller</span></u></td><td><u>Count</u></td><td><u>Time sum, ms</u></td><td><u>Time avg, ms</u></td>";

            ksort($this->hooks);
            foreach ($this->hooks as $key => $val) {
                ksort($val);
                foreach ($val as $k => $v) {
                    $html .= "<tr><td>".$key."</td><td>".$k."</td><td align='center'>".($v['count']>0 ? $v['count'] : "")."</td><td align='center'>".($v['time']>0 ? $v['time'] : "")."</td><td align='center'>".($v['count']>0 ? round($v['time']/$v['count'], 1) : "")."</td></tr>";
                }
            }
            break;
            
        case "act_controls":  // Только активные хуки - по контроллерам
            
            $html_thead = "<td><u><span class='hook'>Controller</span></u></td><td><u><span class='event'>Hook</span></u></td><td><u>Count</u></td><td><u>Time sum, ms</u></td><td><u>Time avg, ms</u></td>";

            // Перегруппируем таблицу сработавших хуков по контроллерам
            ksort($this->hooks);
            foreach ($this->hooks as $key => $val) {
                foreach ($val as $k => $v) {
                    $hooks[$k][$key] = $v;
                }
            }
            
            foreach ($hooks as $key => $val) {
                ksort($val);
                foreach ($val as $k => $v) {
                    $html .= "<tr><td>".$key."</td><td>".$k."</td><td align='center'>".($v['count']>0 ? $v['count'] : "")."</td><td align='center'>".($v['time']>0 ? $v['time'] : "")."</td><td align='center'>".($v['count']>0 ? round($v['time']/$v['count'], 1) : "")."</td></tr>";
                }
            }
            break;
            
        case "all_hooks":  // Все зарегистрированные хуки - по хукам
            
            $html_thead = "<td><u><span class='event'>Hook</span></u></td><td><u><span class='hook'>Controller</span></u></td><td><u>Count</u></td><td><u>Time sum, ms</u></td><td><u>Time avg, ms</u></td>";
            
            // Получаем массив зарегестрированных обработчиков (пар хуков-контроллеров)
            $events = cmsEventsManager::getAllListeners();
            ksort($events);
    
            foreach ($events as $key => $val) {
                // Пропуск строки, если не удовлетворяет фильтру по событию
                if ($this->config->filter_hook_event <> "none") {
                  if ($key != $this->config->filter_hook_event) continue;
                }
                ksort($val);
                foreach ($val as $k => $v) {
                    // Пропуск строки, если не удовлетворяет фильтру по контроллеру
                    if ($this->config->filter_hook_control <> "none") {
                      if ($v != $this->config->filter_hook_control) continue;
                    }
                    $html .= "<tr><td>".$key."</td><td>".$v."</td><td align='center'>".(isset($this->hooks[$key][$v]) ? $this->hooks[$key][$v]['count'] : "")."</td><td align='center'>".(isset($this->hooks[$key][$v]) ? $this->hooks[$key][$v]['time'] : "")."</td><td align='center'>".(isset($this->hooks[$key][$v]) ? round($this->hooks[$key][$v]['time']/$this->hooks[$key][$v]['count'], 1) : "")."</td></tr>";
                }
            }
            break;
            
        case "all_controls":  // Все зарегистрированные хуки - по контроллерам
            
            $html_thead = "<td><u><span class='hook'>Controller</span></u></td><td><u><span class='event'>Hook</span></u></td><td><u>Count</u></td><td><u>Time sum, ms</u></td><td><u>Time avg, ms</u></td>";

            // Получаем массив манифестов контроллеров с хуками
            $manifests = cmsCore::getControllersManifests();
            ksort($manifests);

            foreach ($manifests as $controller => $man) {
                // Пропуск строки, если не удовлетворяет фильтру по контроллеру
                if ($this->config->filter_hook_control <> "none") {
                  if ($controller != $this->config->filter_hook_control) continue;
                }
                asort($man['hooks']);
                foreach ($man['hooks'] as $k => $h) {
                    // Пропуск строки, если не удовлетворяет фильтру по событию
                    if ($this->config->filter_hook_event <> "none") {
                      if ($h != $this->config->filter_hook_event) continue;
                    }
                    $html .= "<tr><td>".$controller."</td><td>".$h."</td><td align='center'>".(isset($this->hooks[$h][$controller]) ? $this->hooks[$h][$controller]['count'] : "")."</td><td align='center'>".(isset($this->hooks[$h][$controller]) ? $this->hooks[$h][$controller]['time'] : "")."</td><td align='center'>".(isset($this->hooks[$h][$controller]) ? round($this->hooks[$h][$controller]['time']/$this->hooks[$h][$controller]['count'], 1) : "")."</td></tr>";
                }
            }
            break;
            
        case "list_events":  // Список произошедших событий
            
            $html_thead = "<td><u><span class='event'>Event</span></u></td><td><u>Count</u></td>";

            ksort($this->events);
            foreach ($this->events as $k => $v) {
                $html .= "<tr><td>".$k."</td><td align='center'>".$this->events[$k]."</td></tr>";
            }
            break;
            
        case "list_hooks":  // Список зарегистрированных хуков
            
            $html_thead = "<td><u><span class='event'>Hook</span></u></td>";

            $listeners = cmsEventsManager::getAllListeners();
            ksort($listeners);
            
            foreach ($listeners as $event => $v) {
                $html .= "<tr><td>".$event."</td></tr>";
            }
            break;
            
        case "list_controls":  // Список контроллеров
            
            $html_thead = "<td><u><span class='hook'>Controller</span></u></td>";

            $manifests = cmsCore::getControllersManifests();
            ksort($manifests);

            foreach ($manifests as $controller_name => $v) {
                $html .= "<tr><td>".$controller_name."</td></tr>";
            }
            break;
    }
    
    $html = "<table><thead><tr>".$html_thead."</tr></thead><tbody>".$html."</tbody></table>";
    
    return $html;
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает готовую html-таблицу с количествами и временем виджетов
  * @return string
  */
  private function getHtmlWidgets() {

    if (!$this->config->debug_on_widget) return "";

    if ($this->config->widget_table_active && count($this->widgets) == 0) return "";
    
    $html = "";

    if (!$this->config->widget_table_active) {
        // Получаем полную таблицу виджетов
        $widgets_list = cmsCore::getModel('widgets')->getAvailableWidgets();

        foreach ($widgets_list as $controller => $wid) {
            if (!$controller) $controller = "";

            // Проверка на фильтр по контроллеру
            if ($this->config->filter_widget_control <> "none") {
                if ($controller != $this->config->filter_widget_control) continue;
            }

            foreach ($wid as $key => $val) {
                $widget_name = $val['name'];
                
                // Проверка на фильтр по имени виджета
                if ($this->config->filter_widget_widget <> "none") {
                    if ($widget_name != $this->config->filter_widget_widget) continue;
                }
                
                $list[$controller][$widget_name]['count'] = "";
                $list[$controller][$widget_name]['time'] = "";
            }
        }
        // Сливаем с массивом количеств
        $widgets = array_replace_recursive($list, $this->widgets);
    } else {
        $widgets = $this->widgets;
    }

    ksort($widgets, SORT_STRING);
    
    foreach ($widgets as $c => $val) {
        ksort($val);
        foreach ($val as $w => $v) {
            $html .= "<tr><td>".$c."</td><td>".$w."</td><td align='center'>".($v['count']>0 ? $v['count'] : "")."</td><td align='center'>".$v['time']."</td><td align='center'>".($v['count']>0 ? round($v['time']/$v['count'], 1) : "")."</td></tr>";
        }
    }
    
    $html = "<table><thead><tr><td><u><span class='widget'>Controller</span></u></td><td><u><span class='widget'>Widget</span></u></td><td><u>Count</u></td><td><u>Time sum, ms</u></td><td><u>Time avg, ms</u></td></tr></thead><tbody>".$html;
    $html .= "</tbody></table>";
    return $html;
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает признак разрешения показывать отладочную информацию
  * @return bool Разрешено показывать отладку или нет
  */
  public function allowShow() {
    return (!$this->config->debug_admin_only || cmsUser::getInstance()->is_admin);
  }

  // ---------------------------------------------------------------------------
  /**
  * Фиксирует начальные время работы и объём памяти на момент старта функций
  * обработки событий для подсчёта времени и памяти класса отладки
  */
  private function startDebugRuntime() {
    $this->debug_time_start = microtime(TRUE);
    $this->debug_memory_start = memory_get_usage();
  }

  // ---------------------------------------------------------------------------
  /**
  * Обновляет время работы и потраченную память класса отладки
  * Требует предварительной корректной фиксации начальных значений
  * $this->debug_time_start и $this->debug_memory_start
  * на момент старта функций обработки событий в отладке
  */
  private function updateDebugRuntime() {
    $this->debug_time += microtime(TRUE) - $this->debug_time_start;
    $this->debug_memory += memory_get_usage() - $this->debug_memory_start;
  }

  // ---------------------------------------------------------------------------
  /**
  * Возвращает округлённое до милисекунд значение времени $time
  * с количеством знаков после запятой $rnd
  * @param float $time Время в секундах
  * @param int $rnd Требуемое количество знаков после запятой
  * @return float Время в милисекундах
  */
  private function timeRound($time, $rnd = 1) {
    return round($time*1000, $rnd);
  }
  
  // ---------------------------------------------------------------------------
  /**
  * Возвращает округлённое до мегабайт значение памяти $mem в байтах
  * с количеством знаков после запятой $rnd
  * @param float $mem Значение памяти в байтах
  * @param int $rnd Требуемое количество знаков после запятой
  * @return float Значение памяти в мегабайтах
  */
  private function memoryRound($mem, $rnd = 3) {
    return round($mem/1048576, $rnd);
  }
  
  // ---------------------------------------------------------------------------
  /**
  * Возвращает процент $part по отношению к $full
  * с количеством знаков после запятой $rnd
  * @param float $full Значение, принимаемое за 100%
  * @param float $part Значение, для которого вычисляется процент
  * @param int $rnd Требуемое количество знаков после запятой
  * @return float Расчётный процент (при $full=0 возвращается 0)
  */
  private function percent($full, $part, $rnd = 0) {
    return ($full==0 ? 0 : round($part/$full * 100, $rnd));
  }
  
  // ---------------------------------------------------------------------------
  /**
  * Возвращает название константы типа ошибки по его номеру
  */
  private function getErrorType($errno) { 
    $err = array ( 
      E_ERROR             => "E_ERROR",
      E_WARNING           => "E_WARNING",
      E_PARSE             => "E_PARSE",
      E_NOTICE            => "E_NOTICE",
      E_CORE_ERROR        => "E_CORE_ERROR",
      E_CORE_WARNING      => "E_CORE_WARNING",
      E_CORE_ERROR        => "E_COMPILE_ERROR",
      E_CORE_WARNING      => "E_COMPILE_WARNING",
      E_USER_ERROR        => "E_USER_ERROR",
      E_USER_WARNING      => "E_USER_WARNING",
      E_USER_NOTICE       => "E_USER_NOTICE",
      E_STRICT            => "E_STRICT",
      E_RECOVERABLE_ERROR => "E_RECOVERABLE_ERROR",
      E_DEPRECATED        => "E_DEPRECATED",
      E_USER_DEPRECATED   => "E_USER_DEPRECATED",
      E_ALL               => "E_ALL"
    );
    return (array_key_exists($errno, $err) ? $err[$errno] : $errno); 
}

// =============================================================================

}
?>